liblzma (XZ Utils): lzma_block Struct Reference

| liblzma (XZ Utils) 5.6.1

- Main Page
- Data Structures
- Files

- Data Structures
- Data Fields

Data Fields
lzma_block Struct Reference

Options for the Block and Block Header encoders and decoders. More...

`#include <block.h>`

## Data Fields
uint32_t | version
| Block format version.
uint32_t | header_size
| Size of the Block Header field in bytes.
lzma_check | check
| Type of integrity Check.
lzma_vli | compressed_size
| Size of the Compressed Data in bytes.
lzma_vli | uncompressed_size
| Uncompressed Size in bytes.
lzma_filter * | filters
| Array of filters.
uint8_t | raw_check [LZMA_CHECK_SIZE_MAX]
| Raw value stored in the Check field.
lzma_bool | ignore_check
| A flag to Block decoder to not verify the Check field.

## Detailed Description

Options for the Block and Block Header encoders and decoders.

Different Block handling functions use different parts of this structure. Some read some members, other functions write, and some do both. Only the members listed for reading need to be initialized when the specified functions are called. The members marked for writing will be assigned new values at some point either by calling the given function or by later calls to lzma_code().

## Field Documentation

## ◆ version

uint32_t lzma_block::version

Block format version.

To prevent API and ABI breakages when new features are needed, a version number is used to indicate which members in this structure are in use:

- liblzma >= 5.0.0: version = 0 is supported.
- liblzma >= 5.1.4beta: Support for version = 1 was added, which adds the ignore_check member.

If version is greater than one, most Block related functions will return LZMA_OPTIONS_ERROR (lzma_block_header_decode() works with any version value).

Read by:

- lzma_block_header_size()
- lzma_block_header_encode()
- lzma_block_header_decode()
- lzma_block_compressed_size()
- lzma_block_unpadded_size()
- lzma_block_total_size()
- lzma_block_encoder()
- lzma_block_decoder()
- lzma_block_buffer_encode()
- lzma_block_uncomp_encode()
- lzma_block_buffer_decode()

Written by:

- lzma_block_header_decode()

## ◆ header_size

uint32_t lzma_block::header_size

Size of the Block Header field in bytes.

This is always a multiple of four.

Read by:

- lzma_block_header_encode()
- lzma_block_header_decode()
- lzma_block_compressed_size()
- lzma_block_unpadded_size()
- lzma_block_total_size()
- lzma_block_decoder()
- lzma_block_buffer_decode()

Written by:

- lzma_block_header_size()
- lzma_block_buffer_encode()
- lzma_block_uncomp_encode()

## ◆ check

lzma_check lzma_block::check

Type of integrity Check.

The Check ID is not stored into the Block Header, thus its value must be provided also when decoding.

Read by:

- lzma_block_header_encode()
- lzma_block_header_decode()
- lzma_block_compressed_size()
- lzma_block_unpadded_size()
- lzma_block_total_size()
- lzma_block_encoder()
- lzma_block_decoder()
- lzma_block_buffer_encode()
- lzma_block_buffer_decode()

## ◆ compressed_size

lzma_vli lzma_block::compressed_size

Size of the Compressed Data in bytes.

Encoding: If this is not LZMA_VLI_UNKNOWN, Block Header encoder will store this value to the Block Header. Block encoder doesn't care about this value, but will set it once the encoding has been finished.

Decoding: If this is not LZMA_VLI_UNKNOWN, Block decoder will verify that the size of the Compressed Data field matches compressed_size.

Usually you don't know this value when encoding in streamed mode, and thus cannot write this field into the Block Header.

In non-streamed mode you can reserve space for this field before encoding the actual Block. After encoding the data, finish the Block by encoding the Block Header. Steps in detail:

- Set compressed_size to some big enough value. If you don't know better, use LZMA_VLI_MAX, but remember that bigger values take more space in Block Header.
- Call lzma_block_header_size() to see how much space you need to reserve for the Block Header.
- Encode the Block using lzma_block_encoder() and lzma_code(). It sets compressed_size to the correct value.
- Use lzma_block_header_encode() to encode the Block Header. Because space was reserved in the first step, you don't need to call lzma_block_header_size() anymore, because due to reserving, header_size has to be big enough. If it is "too big", lzma_block_header_encode() will add enough Header Padding to make Block Header to match the size specified by header_size.

Read by:

- lzma_block_header_size()
- lzma_block_header_encode()
- lzma_block_compressed_size()
- lzma_block_unpadded_size()
- lzma_block_total_size()
- lzma_block_decoder()
- lzma_block_buffer_decode()

Written by:

- lzma_block_header_decode()
- lzma_block_compressed_size()
- lzma_block_encoder()
- lzma_block_decoder()
- lzma_block_buffer_encode()
- lzma_block_uncomp_encode()
- lzma_block_buffer_decode()

## ◆ uncompressed_size

lzma_vli lzma_block::uncompressed_size

Uncompressed Size in bytes.

This is handled very similarly to compressed_size above.

uncompressed_size is needed by fewer functions than compressed_size. This is because uncompressed_size isn't needed to validate that Block stays within proper limits.

Read by:

- lzma_block_header_size()
- lzma_block_header_encode()
- lzma_block_decoder()
- lzma_block_buffer_decode()

Written by:

- lzma_block_header_decode()
- lzma_block_encoder()
- lzma_block_decoder()
- lzma_block_buffer_encode()
- lzma_block_uncomp_encode()
- lzma_block_buffer_decode()

## ◆ filters

lzma_filter* lzma_block::filters

Array of filters.

There can be 1-4 filters. The end of the array is marked with .id = LZMA_VLI_UNKNOWN.

Read by:

- lzma_block_header_size()
- lzma_block_header_encode()
- lzma_block_encoder()
- lzma_block_decoder()
- lzma_block_buffer_encode()
- lzma_block_buffer_decode()

Written by:

- lzma_block_header_decode(): Note that this does NOT free() the old filter options structures. All unused filters[] will have .id == LZMA_VLI_UNKNOWN and .options == NULL. If decoding fails, all filters[] are guaranteed to be LZMA_VLI_UNKNOWN and NULL.

Note
  Because of the array is terminated with .id = LZMA_VLI_UNKNOWN, the actual array must have LZMA_FILTERS_MAX + 1 members or the Block Header decoder will overflow the buffer.

## ◆ raw_check

uint8_t lzma_block::raw_check[LZMA_CHECK_SIZE_MAX]

Raw value stored in the Check field.

After successful coding, the first lzma_check_size(check) bytes of this array contain the raw value stored in the Check field.

Note that CRC32 and CRC64 are stored in little endian byte order. Take it into account if you display the Check values to the user.

Written by:

- lzma_block_encoder()
- lzma_block_decoder()
- lzma_block_buffer_encode()
- lzma_block_uncomp_encode()
- lzma_block_buffer_decode()

## ◆ ignore_check

lzma_bool lzma_block::ignore_check

A flag to Block decoder to not verify the Check field.

This member is supported by liblzma >= 5.1.4beta if .version >= 1.

If this is set to true, the integrity check won't be calculated and verified. Unless you know what you are doing, you should leave this to false. (A reason to set this to true is when the file integrity is verified externally anyway and you want to speed up the decompression, which matters mostly when using SHA-256 as the integrity check.)

If .version >= 1, read by:

- lzma_block_decoder()
- lzma_block_buffer_decode()

Written by (.version is ignored):

- lzma_block_header_decode() always sets this to false

The documentation for this struct was generated from the following file:

- lzma/block.h

XZ logo © 2023 by Jia Tan is licensed under CC BY-SA 4.0